// Rsolution d'une quation diffrentielle
// par la mthode d'Euler

function z=f(x,y)
//===============
  z = y;
endfunction

function y=EulerExplicite(a,b,y0,n)
//=================================
// pour la condition initiale  y(a) = y0
// rsoud l'quation diffrentielle y'(x)=f(x,y(x))
// pour  x  variant de  a    b
// retourne un vecteur de  n  valeurs de  y.
y    = zeros(1, n+1);
y(1) = y0;
h    = (b-a)/n;
for k=1:n do
  x = a + (k-1)*h  
  y(k+1) = y(k) + h*f(x, y(k));
  end;
endfunction

// Utilisation de la rsolution
// donnes :
a  = 0;
b  = 2;
y0 = 1;
n  = 10;

// rsolution numrique
y  = EulerExplicite(a,b,y0,n);

// graphique de la solution numrique
h = (b-a)/n;
x = a:h:b;
clf;
plot(x,y);

// comparaison  la solution exacte.
yex = exp(x);
plot(x,yex,"r");
