// Rsolution d'une quation diffrentielle
// par la mthode d'Euler

// constantes du problme.
g = 9.81;   k_m = 0.12;

function z=f(t,y)
//===============
  z = g - k_m * y;
endfunction

function y=EulerExplicite(a,b,y0,n)
//=================================
// pour la condition initiale  y(a) = y0
// rsoud l'quation diffrentielle y'(t)=f(t,y(t))
// pour  t  variant de  a    b
// retourne un vecteur de  n  valeurs de  y.
y    = zeros(1, n+1);
y(1) = y0;
h    = (b-a)/n;
for k=1:n do
  t = a + (k-1)*h  
  y(k+1) = y(k) + h*f(t, y(k));
  end;
endfunction

// Utilisation de la rsolution
// donnes :
a  = 0;
b  = 50;
y0 = 0;
n  = 30;

// rsolution numrique
y  = EulerExplicite(a,b,y0,n);

// graphique de la solution numrique
h = (b-a)/n;
t = a:h:b;
clf;
plot(t,y);

// comparaison  la solution exacte.
C = -g/k_m;
yex = C*exp(-k_m*t) + g/k_m;
plot(t,yex,"r");
