// Rsolution d'une quation diffrentielle
// par la mthode d'Euler

function z=f(t,y)
//===============
// pour rsoudre  y'' = -y
// solution  y(t) = c1*cos(t) + c2*sin(t)
// y(1) = y   y(2) = y'
// z(1) = y'  z(2) = y''
z(1) = y(2);
z(2) = -y(1);
endfunction

function y=EulerExplicite(a,b,y0,n)
//=================================
// pour la condition initiale  y(a) = y0
// rsoud l'quation diffrentielle y'(t)=f(t,y(t))
// pour  t  variant de  a    b
// retourne un vecteur de  n  valeurs de  y.
y    = zeros(length(y0), n+1);
y(:,1) = y0;
h    = (b-a)/n;
for k=1:n do
  t = a + (k-1)*h  
  y(:,k+1) = y(:,k) + h*f(t, y(:,k));
  end;
endfunction

// Utilisation de la rsolution
// donnes :
a  = 0;
b  = 7;
y0 = [0; 1];
n  = 40;

// rsolution numrique
y  = EulerExplicite(a,b,y0,n);

// graphique de la solution numrique
h = (b-a)/n;
x = a:h:b;
clf;
plot(x,y(1,:));

// comparaison  la solution exacte.
yex = sin(x);
plot(x,yex,"r");
