// Rsolution d'une quation diffrentielle
// par une mthode d'ordre 2

function z=f(t,y)
//===============
  z = y;
endfunction

function y=Ordre2(a,b,y0,n)
//=========================
// pour la condition initiale  y(a) = y0
// rsoud l'quation diffrentielle y'(t)=f(t,y(t))
// pour  t  variant de  a    b
// retourne un vecteur de  n  valeurs de  y.
y    = zeros(1, n+1);
y(1) = y0;
h    = (b-a)/n;

for k=1:n do
  t = a + (k-1)*h
  k1 = f(t, y(k));
  k2 = f(t + h/2, y(k) + k1 * h/2);
  y(k+1) = y(k) + h*k2;
  end;
endfunction

// Utilisation de la rsolution
// donnes :
a  = 0;
b  = 2;
y0 = 1;
n  = 10;

// rsolution numrique
y  = Ordre2(a,b,y0,n);

// graphique de la solution numrique
h = (b-a)/n;
x = a:h:b;
clf;
plot(x,y);

// comparaison  la solution exacte.
yex = exp(x);
plot(x,yex,"r");
