// Rsolution d'une quation diffrentielle
// par LA mthode de Runge-Kutta, qui est d'ordre 4

function z=f(t,y)
//===============
//  z = y;
z = y^2 - t;
endfunction

function y=Ordre4(a,b,y0,n)
//=========================
// pour la condition initiale  y(a) = y0
// rsoud l'quation diffrentielle y'(t)=f(t,y(t))
// pour  t  variant de  a    b
// retourne un vecteur de  n  valeurs de  y.
y    = zeros(1, n+1);
y(1) = y0;
h    = (b-a)/n;

for k=1:n do
  t = a + (k-1)*h
  k1 = f(t      , y(k)           );
  k2 = f(t + h/2, y(k) + k1 * h/2);
  k3 = f(t + h/2, y(k) + k2 * h/2);
  k4 = f(t + h  , y(k) + k3 * h  );
  y(k+1) = y(k) + h*(k1 + 2*k2 + 2*k3 + k4)/6;
  end;
endfunction

// Utilisation de la rsolution
// donnes :
a  = 0;
b  = 1;
y0 = 1;    y0=0;
n  = 50;

// rsolution numrique
y  = Ordre4(a,b,y0,n);

// graphique de la solution numrique
h = (b-a)/n;
x = a:h:b;
clf;
plot(x,y);
disp("y(" + string(b) + ")= " + string(y(n+1)));

// en utilisant le solveur de SciLab.
y2 = ode(y0,a,x,1e-12,1e-12,f);
disp("y(" + string(b) + ")= " + string(y2(n+1)));

// comparaison  la solution exacte.
yex = exp(x);
//plot(x,yex,"r");
