// Le but est de calculer par simulation la probabilit
// que deux personnes aient leur anniversaire le mme jour,
// dans un groupe de  n  personnes.

// donnes :
nRepet = 10000; // nombre de fois que l'on rptera la simulation
nPersonne  = 15;  // nombre de personnes du groupe.

rand("uniform");
a = zeros(1, nPersonne);

nbCoincid = 0; // nombre de coincidences.
for nn = 1:nRepet do
  // on tire au hazard leur jour de naissance dans une anne de 365 jours
  for k = 1:nPersonne do
    a(k) = floor(365*rand());
  end // for

  // triage par ordre croissant des jours de naissances.
  a = gsort(a);

  // vrifie si deux personnes ont leur anniversaire le mme jour.
  for k = 2:nPersonne do
    if (a(k-1) == a(k)) then
      nbCoincid = nbCoincid + 1;
      break;  // sort de la boucle.
    end;
  end // for  
end // for

disp("Probabilit ~= " + string(nbCoincid / nRepet));

// Calcul exacte de cette probabilit.
// Prob. = 1 - 364/365 * 363/365 * 362/365 * ... * (365-nPersonne+1)/365

prob = 1;
for k = 2:nPersonne do
  prob = prob * (366-k)/365;
end;

disp("Probabilit = " + string(1 - prob));
