// Automate cellulaire, "Le jeu de la vie de John Conway"

function u = createur(m,n);
//=========================
// cre le tableau cellulaire et le rempli au hazard
rand("uniform");
u = zeros(m+1, n+1);
//for k = 3:m-3 do
//  for c = 3:n-3
//    if (rand() < 0.5) then
//      u(k, c) = 1;
//    end
//  end
//end
u(6-2,2) = 1;
u(6-2,3) = 1;
u(6-2,4) = 1;
u(6-3,4) = 1;
u(6-4,3) = 1;

//u(m-3,2) = 1;
//u(m-3,3) = 1;
//u(m-3,4) = 1;
endfunction

function visualisation(u,v);
//========================
[m, n] = size(u);
//clf();
square(1,1,n,m);
for k = 2:m-1 do
  for c = 2:n-1 do  
    
    // efface l'ancienne cellule
    if (u(k, c) == 1) then 
      plot(c, k, 'xw');
    end
    
    // ajoute la nouvelle cellule
    if (v(k, c) == 1) then 
      plot(c, k, 'xk');
    end
  end
end
endfunction

function v=evolution(u);
//======================
[m, n] = size(u);
v = u;
for k = 2:m-1 do
  for c = 2:n-1 do  
    //  s = nombre d'emplacements voisins occupes
    s = u(k-1,c-1) + u(k  ,c-1) + u(k+1,c-1) +..
        u(k-1,c  ) +              u(k+1,c  ) +..
        u(k-1,c+1) + u(k  ,c+1) + u(k+1,c+1);
        
    if (s == 3) then 
      v(k,c) = 1;      
    elseif ((s <= 1) | (s >= 4)) then
      v(k,c) = 0;
    end
  end // for c
end // for k
endfunction

// Programme ***
m  = 10;  // nombre de lignes
n  = 10;  // nombre de colonnes
ni = 25;  // nombre d'itration
u  = createur(m,n);
clf();
visualisation(u,u);
sleep(1000);  // attente en [ms]

// Evolution
for k = 1:ni do
  v = evolution(u);
  visualisation(u,v);
  u = v;
  sleep(100);
end
